<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) 2.1.16 Update #4                                        |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2012 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | Contentteller is not free software. You may not redistribute this file   |
// | or its derivatives without written permission.                           |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Build: 824.97.120908-140829                                              |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Articles
 * @copyright (C) 2002-2012 Esselbach Internet Solutions
 */

/**
 * function ArticlesRSS
 * A function to show article RSS feed
 * @author Philipp Louis Esselbach
 */
function ArticlesRSS( $page )
{
	global $database, $system, $templates, $preferences, $security, $config, $user;
	$currentdate = date( "Y-m-d H:i:s", mktime() );

	$seo_url = ( $preferences[ 'website_mod_rewrite' ] ) ? "" : "index" . $preferences[ 'param_ext' ] . $preferences[ 'param_ct' ] ;

	if( $preferences[ 'articles_allow_rss' ] )
	{
		$main_templates = $templates -> preparetemplates( "'articles_rss_header','articles_rss_copyright','articles_rss_editor','articles_rss_webmaster','articles_rss_item','articles_rss_footer'", $preferences[ 'current_theme' ] );

		if( $user[ 'user_status' ] == 1 )
		{
			$article_status = "(article_status = '0' OR article_status = '1' OR article_status = '3')";
		}
		elseif( $user[ 'user_status' ] == 2 or $user[ 'user_status' ] == 3 )
		{
			$article_status = "(article_status = '0' OR article_status = '1' OR article_status = '2' OR article_status = '3' OR article_status = '4')";
		}
		elseif( $user[ 'user_status' ] == 6 )
		{
			$article_status = "(article_status = '0' OR article_status = '1' OR article_status = '3' OR article_status = '4')";
		}
		else
		{
			$article_status = "(article_status = '0' OR article_status = '3')";
		}


		if( $preferences[ 'articles_start_expire_date' ] )
		{
			$articles_expire_sql = " AND article_startdate < '" . $currentdate . "' AND (article_expiredate > '" . $currentdate . "' OR article_neverexpire = '1')";
		}
		else
		{
			$articles_expire_sql = "";
		}

		$insert[ 'rss_charset' ] = htmlspecialchars( $preferences[ 'website_charset' ] );
		$insert[ 'rss_pubdate' ] = date( "r", mktime() );
		$insert[ 'rss_language' ] = $preferences[ 'articles_rss_language' ];
		$currentdate = date( "Y-m-d H:i:s", mktime() );

		if( $preferences[ 'articles_rss_copyright' ] )
		{
			$insert[ 'rss_copyright' ] = strip_tags( $preferences[ 'articles_rss_copyright' ] );
			$insert[ 'rss_copyright_line' ] = $templates -> exectemplate( $main_templates[ 'articles_rss_copyright_html' ], $main_templates[ 'articles_rss_copyright_php' ], $insert ) . "\n";
		}
		else
		{
			$insert[ 'rss_copyright_line' ] = "";
		}

		if( $preferences[ 'articles_rss_editor' ] )
		{
			$insert[ 'rss_editor' ] = strip_tags( $preferences[ 'articles_rss_editor' ] );
			$insert[ 'rss_editor_line' ] = $templates -> exectemplate( $main_templates[ 'articles_rss_editor_html' ], $main_templates[ 'articles_rss_editor_php' ], $insert ) . "\n";
		}
		else
		{
			$insert[ 'rss_editor_line' ] = "";
		}

		if( $preferences[ 'articles_rss_webmaster' ] )
		{
			$insert[ 'rss_webmaster' ] = strip_tags( $preferences[ 'articles_rss_webmaster' ] );
			$insert[ 'rss_webmaster_line' ] = $templates -> exectemplate( $main_templates[ 'articles_rss_webmaster_html' ], $main_templates[ 'articles_rss_webmaster_php' ], $insert ) . "\n";
		}
		else
		{
			$insert[ 'rss_webmaster_line' ] = "";
		}

		if( $preferences[ 'website_stats_rss_readers' ] )
		{
			$stats_month = date( "m" );
			$stats_year = date( "Y" );
			$stats_agent = ( isset( $_SERVER[ 'HTTP_USER_AGENT' ] ) ) ? $security -> checkvar( $_SERVER[ 'HTTP_USER_AGENT' ] ) : "" ;
			$query = $database -> dbquery( "SELECT statrssreader_id FROM " . DB_PREFIX . "esselbach_ct_statsrssreaders WHERE statrssreader_month = '" . $stats_month . "' AND statrssreader_year = '" . $stats_year . "' AND statrssreader_agent = '" . $stats_agent . "' AND statrssreader_website = '" . intval( $config[ 'WEBSITE' ] ) . "' LIMIT 1" );

			if( $database -> dbrows( $query ) )
			{
				$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_statsrssreaders SET statrssreader_count = statrssreader_count + 1 WHERE statrssreader_month = '" . $stats_month . "' AND statrssreader_year = '" . $stats_year . "' AND statrssreader_agent = '" . $stats_agent . "' AND statrssreader_website = '" . intval( $config[ 'WEBSITE' ] ) . "'" );
			}
			else
			{
				$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_statsrssreaders (statrssreader_id, statrssreader_website, statrssreader_month, statrssreader_year, statrssreader_agent, statrssreader_count) VALUES (NULL, '" . intval( $config[ 'WEBSITE' ] ) . "', '" . $stats_month . "', '" . $stats_year . "', '" . $stats_agent . "', '1')" );
			}

			$query = $database -> dbquery( "SELECT statcount_id FROM " . DB_PREFIX . "esselbach_ct_statscounter WHERE statcount_month = '" . $stats_month . "' AND statcount_year = '" . $stats_year . "' AND statcount_website = '" . intval( $config[ 'WEBSITE' ] ) . "' LIMIT 1" );

			if( $database -> dbrows( $query ) )
			{
				$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_statscounter SET statcount_rssviews = statcount_rssviews + 1 WHERE statcount_month = '" . $stats_month . "' AND statcount_year = '" . $stats_year . "' AND statcount_website = '" . intval( $config[ 'WEBSITE' ] ) . "'" );
			}
			else
			{
				$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_statscounter (statcount_id, statcount_website, statcount_month, statcount_year, statcount_pageviews, statcount_rssviews) VALUES (NULL, '" . intval( $config[ 'WEBSITE' ] ) . "', '" . $stats_month . "', '" . $stats_year . "', '0', '1')" );
			}
		}

		if( !$page )
		{
			$insert[ 'rss_sitename' ] = strip_tags( htmlspecialchars(  $preferences[ 'website_name' ] ) );
			$insert[ 'rss_siteurl' ] = strip_tags( $preferences[ 'website_url' ] );
			$insert[ 'rss_description' ] = strip_tags( $preferences[ 'website_description' ] );
			$query = $database -> dbquery( "SELECT article_date FROM " . DB_PREFIX . "esselbach_ct_articles WHERE " . $article_status . " AND (article_website = '0' OR article_website = '" . $preferences[ 'current_website' ] . "')" . $articles_expire_sql . " ORDER BY article_date DESC LIMIT 1" );

			if( $database -> dbrows( $query ) )
			{
				list( $article_date ) = $database -> dbrow( $query );
				$insert[ 'rss_lastbuild' ] = date( "r", strtotime( $article_date ) );
			}
			else
			{
				exit;
			}

			header( "content-type: text/xml" );
			echo $templates -> exectemplate( $main_templates[ 'articles_rss_header_html' ], $main_templates[ 'articles_rss_header_php' ], $insert ) . "\n";
			$query = $database -> dbquery( "SELECT article_title, article_seo, article_description, article_date FROM " . DB_PREFIX . "esselbach_ct_articles WHERE " . $article_status . " AND (article_website = '0' OR article_website = '" . $preferences[ 'current_website' ] . "')" . $articles_expire_sql . " ORDER BY article_date DESC LIMIT 20" );
		}
		else
		{
			$page_query = $system -> getpage( $page );
			$query = $database -> dbquery( "SELECT articlecat_id, articlecat_name, articlecat_seo, articlecat_description FROM " . DB_PREFIX . "esselbach_ct_articlescats WHERE articlecat_seo = '" . $page_query . "' AND (articlecat_website = '0' OR articlecat_website = '" . $preferences[ 'current_website' ] . "') LIMIT 1" );

			if( $database -> dbrows( $query ) )
			{
				list( $articlecat_id, $articlecat_name, $articlecat_seo, $articlecat_description ) = $database -> dbrow( $query );

				if ( $preferences[ 'website_seo_hyphens' ] )
				{
					$articlecat_seo = str_replace( "_", "-", $articlecat_seo );
				}

				$insert[ 'rss_sitename' ] = strip_tags( htmlspecialchars( $preferences[ 'website_name' ] ) . " - " . strip_tags( $articlecat_name ) );
				$insert[ 'rss_siteurl' ] = strip_tags( $preferences[ 'website_url' ] ) . "/" . $seo_url ."articles" . $preferences[ 'param_action' ] . "categories" . $preferences[ 'param_page' ] . $articlecat_seo . ".xml";
				$insert[ 'rss_description' ] = strip_tags( $articlecat_description );
			}
			else
			{
				exit;
			}

			$articlecat_id = $database -> dbescape( $articlecat_id );
			$query = $database -> dbquery( "SELECT article_date FROM " . DB_PREFIX . "esselbach_ct_articles WHERE " . $article_status . " AND article_category = '" . $articlecat_id . "' AND (article_website = '0' OR article_website = '" . $preferences[ 'current_website' ] . "')" . $articles_expire_sql . " ORDER BY article_date DESC LIMIT 1" );

			if( $database -> dbrows( $query ) )
			{
				list( $article_date ) = $database -> dbrow( $query );
				$insert[ 'rss_lastbuild' ] = date( "r", strtotime( $article_date ) );
			}
			else
			{
				$insert[ 'rss_lastbuild' ] = date( "r", mktime() );
			}

			header( "content-type: text/xml" );
			echo $templates -> exectemplate( $main_templates[ 'articles_rss_header_html' ], $main_templates[ 'articles_rss_header_php' ], $insert ) . "\n";
			$query = $database -> dbquery( "SELECT article_title, article_seo, article_description, article_date FROM " . DB_PREFIX . "esselbach_ct_articles WHERE " . $article_status . " AND article_category = '" . $articlecat_id . "' AND (article_website = '0' OR article_website = '" . $preferences[ 'current_website' ] . "')" . $articles_expire_sql . " ORDER BY article_date DESC LIMIT 20" );
		}

		if( $database -> dbrows( $query ) )
		{
			if ( $preferences[ 'website_seo_hyphens' ] )
			{
				$preferences[ 'param_action' ] = str_replace( "_", "-", $preferences[ 'param_action' ] );
			}

			while( list( $article_title, $article_seo, $article_description, $article_date ) = $database -> dbrow( $query ) )
			{
				if ( $preferences[ 'website_seo_hyphens' ] )
				{
					$article_seo = str_replace( "_", "-", $article_seo );
				}

				$insert[ 'article_title' ] = strip_tags( htmlspecialchars( $article_title ) );
				$insert[ 'article_link' ] = strip_tags( $preferences[ 'website_url' ] ) . "/" . $seo_url . "articles" . $preferences[ 'param_action' ] . "summary" . $preferences[ 'param_page' ] . $article_seo . ".html";
				$insert[ 'article_description' ] = strip_tags( htmlspecialchars( $article_description ) );
				$insert[ 'article_startdate' ] = date( "r", strtotime( $article_date ) );
				echo $templates -> exectemplate( $main_templates[ 'articles_rss_item_html' ], $main_templates[ 'articles_rss_item_php' ], $insert ) . "\n";
			}
		}

		echo $templates -> exectemplate( $main_templates[ 'articles_rss_footer_html' ], $main_templates[ 'articles_rss_footer_php' ], $insert );
	}
}
?>