<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) 2.1.16 Update #4                                        |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2012 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | Contentteller is not free software. You may not redistribute this file   |
// | or its derivatives without written permission.                           |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Build: 824.97.120908-140829                                              |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Files
 * @copyright (C) 2002-2012 Esselbach Internet Solutions
 */

/**
 * function FilesRSS
 * A function to the files RSS feed
 * @author Philipp Louis Esselbach
 */
function FilesRSS( $page )
{
	global $database, $templates, $preferences, $config, $security, $user;
	$currentdate = date( "Y-m-d H:i:s", mktime() );

	$seo_url = ( $preferences[ 'website_mod_rewrite' ] ) ? "" : "index" . $preferences[ 'param_ext' ] . $preferences[ 'param_ct' ] ;

	if( $preferences[ 'files_allow_rss' ] )
	{
		$main_templates = $templates -> preparetemplates( "'files_rss_header','files_rss_copyright','files_rss_editor','files_rss_webmaster','files_rss_item','files_rss_footer'", $preferences[ 'current_theme' ] );

		if( $user[ 'user_status' ] == 1 )
		{
			$file_status = "(file_status = '0' OR file_status = '1' OR file_status = '3')";
		}
		elseif( $user[ 'user_status' ] == 2 or $user[ 'user_status' ] == 3 )
		{
			$file_status = "(file_status = '0' OR file_status = '1' OR file_status = '2' OR file_status = '3' OR file_status = '4')";
		}
		elseif( $user[ 'user_status' ] == 6 )
		{
			$file_status = "(file_status = '0' OR file_status = '1' OR file_status = '3' OR file_status = '4')";
		}
		else
		{
			$file_status = "(file_status = '0' OR file_status = '3')";
		}

		if( $preferences[ 'files_start_expire_date' ] )
		{
			$files_expire_sql = " AND file_startdate < '" . $currentdate . "' AND (file_expiredate > '" . $currentdate . "' OR file_neverexpire = '1')";
		}
		else
		{
			$files_expire_sql = "";
		}

		$insert[ 'rss_charset' ] = htmlspecialchars( $preferences[ 'website_charset' ] );
		$insert[ 'rss_pubdate' ] = date( "r", mktime() );
		$insert[ 'rss_language' ] = $preferences[ 'files_rss_language' ];
		$currentdate = date( "Y-m-d H:i:s", mktime() );

		if( $preferences[ 'files_rss_copyright' ] )
		{
			$insert[ 'rss_copyright' ] = strip_tags( $preferences[ 'files_rss_copyright' ] );
			$insert[ 'rss_copyright_line' ] = $templates -> exectemplate( $main_templates[ 'files_rss_copyright_html' ], $main_templates[ 'files_rss_copyright_php' ], $insert ) . "\n";
		}
		else
		{
			$insert[ 'rss_copyright_line' ] = "";
		}

		if( $preferences[ 'files_rss_editor' ] )
		{
			$insert[ 'rss_editor' ] = strip_tags( $preferences[ 'files_rss_editor' ] );
			$insert[ 'rss_editor_line' ] = $templates -> exectemplate( $main_templates[ 'files_rss_editor_html' ], $main_templates[ 'files_rss_editor_php' ], $insert ) . "\n";
		}
		else
		{
			$insert[ 'rss_editor_line' ] = "";
		}

		if( $preferences[ 'files_rss_webmaster' ] )
		{
			$insert[ 'rss_webmaster' ] = strip_tags( $preferences[ 'files_rss_webmaster' ] );
			$insert[ 'rss_webmaster_line' ] = $templates -> exectemplate( $main_templates[ 'files_rss_webmaster_html' ], $main_templates[ 'files_rss_webmaster_php' ], $insert ) . "\n";
		}
		else
		{
			$insert[ 'rss_webmaster_line' ] = "";
		}

		if( $preferences[ 'website_stats_rss_readers' ] )
		{
			$stats_month = date( "m" );
			$stats_year = date( "Y" );
			$stats_agent = ( isset( $_SERVER[ 'HTTP_USER_AGENT' ] ) ) ? $security -> checkvar( $_SERVER[ 'HTTP_USER_AGENT' ] ) : "" ;
			$query = $database -> dbquery( "SELECT statrssreader_id FROM " . DB_PREFIX . "esselbach_ct_statsrssreaders WHERE statrssreader_month = '" . $stats_month . "' AND statrssreader_year = '" . $stats_year . "' AND statrssreader_agent = '" . $stats_agent . "' AND statrssreader_website = '" . intval( $config[ 'WEBSITE' ] ) . "' LIMIT 1" );

			if( $database -> dbrows( $query ) )
			{
				$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_statsrssreaders SET statrssreader_count = statrssreader_count + 1 WHERE statrssreader_month = '" . $stats_month . "' AND statrssreader_year = '" . $stats_year . "' AND statrssreader_agent = '" . $stats_agent . "' AND statrssreader_website = '" . intval( $config[ 'WEBSITE' ] ) . "'" );
			}
			else
			{
				$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_statsrssreaders (statrssreader_id, statrssreader_website, statrssreader_month, statrssreader_year, statrssreader_agent, statrssreader_count) VALUES (NULL, '" . intval( $config[ 'WEBSITE' ] ) . "', '" . $stats_month . "', '" . $stats_year . "', '" . $stats_agent . "', '1')" );
			}

			$query = $database -> dbquery( "SELECT statcount_id FROM " . DB_PREFIX . "esselbach_ct_statscounter WHERE statcount_month = '" . $stats_month . "' AND statcount_year = '" . $stats_year . "' AND statcount_website = '" . intval( $config[ 'WEBSITE' ] ) . "' LIMIT 1" );

			if( $database -> dbrows( $query ) )
			{
				$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_statscounter SET statcount_rssviews = statcount_rssviews + 1 WHERE statcount_month = '" . $stats_month . "' AND statcount_year = '" . $stats_year . "' AND statcount_website = '" . intval( $config[ 'WEBSITE' ] ) . "'" );
			}
			else
			{
				$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_statscounter (statcount_id, statcount_website, statcount_month, statcount_year, statcount_pageviews, statcount_rssviews) VALUES (NULL, '" . intval( $config[ 'WEBSITE' ] ) . "', '" . $stats_month . "', '" . $stats_year . "', '0', '1')" );
			}
		}

		if( !$page )
		{
			$insert[ 'rss_sitename' ] = strip_tags( htmlspecialchars(  $preferences[ 'website_name' ] ) );
			$insert[ 'rss_siteurl' ] = strip_tags( $preferences[ 'website_url' ] );
			$insert[ 'rss_description' ] = strip_tags( $preferences[ 'website_description' ] );
			$query = $database -> dbquery( "SELECT file_date FROM " . DB_PREFIX . "esselbach_ct_files WHERE " . $file_status . " AND (file_website = '0' OR file_website = '" . $preferences[ 'current_website' ] . "')" . $files_expire_sql . " ORDER BY file_date DESC LIMIT 1" );

			if( $database -> dbrows( $query ) )
			{
				list( $file_date ) = $database -> dbrow( $query );
				$insert[ 'rss_lastbuild' ] = date( "r", strtotime( $file_date ) );
			}
			else
			{
				exit;
			}

			header( "content-type: text/xml" );
			echo $templates -> exectemplate( $main_templates[ 'files_rss_header_html' ], $main_templates[ 'files_rss_header_php' ], $insert ) . "\n";
			$query = $database -> dbquery( "SELECT file_name, file_version, file_seo, file_description, file_date FROM " . DB_PREFIX . "esselbach_ct_files WHERE " . $file_status . " AND (file_website = '0' OR file_website = '" . $preferences[ 'current_website' ] . "')" . $files_expire_sql . " ORDER BY file_date DESC LIMIT 20" );
		}
		else
		{
			$page_data = explode( ".", $page );
			$page_query = $database -> dbescape( $page_data[ 0 ] );
			$query = $database -> dbquery( "SELECT filecat_id, filecat_name, filecat_seo, filecat_description FROM " . DB_PREFIX . "esselbach_ct_filescats WHERE filecat_seo = '" . $page_query . "' AND (filecat_website = '0' OR filecat_website = '" . $preferences[ 'current_website' ] . "') LIMIT 1" );

			if( $database -> dbrows( $query ) )
			{
				list( $filecat_id, $filecat_name, $filecat_seo, $filecat_description ) = $database -> dbrow( $query );
				if ( $preferences[ 'website_seo_hyphens' ] )
				{
					$filecat_seo = str_replace( "_", "-", $filecat_seo );
				}

				$insert[ 'rss_sitename' ] = strip_tags( htmlspecialchars( $preferences[ 'website_name' ] ) . " - " . strip_tags( $filecat_name ) );
				$insert[ 'rss_siteurl' ] = strip_tags( $preferences[ 'website_url' ] ) . "/" . $seo_url . "files" . $preferences[ 'param_action' ] . "categories" . $preferences[ 'param_page' ] . $filecat_seo . ".xml";
				$insert[ 'rss_description' ] = strip_tags( htmlspecialchars( $filecat_description ) );
			}
			else
			{
				exit;
			}

			$filecat_id = $database -> dbescape( $filecat_id );
			$query = $database -> dbquery( "SELECT file_date FROM " . DB_PREFIX . "esselbach_ct_files WHERE " . $file_status . " AND file_category = '" . $filecat_id . "' AND (file_website = '0' OR file_website = '" . $preferences[ 'current_website' ] . "')" . $files_expire_sql . " ORDER BY file_date DESC LIMIT 1" );

			if( $database -> dbrows( $query ) )
			{
				list( $file_date ) = $database -> dbrow( $query );
				$insert[ 'rss_lastbuild' ] = date( "r", strtotime( $file_date ) );
			}
			else
			{
				$insert[ 'rss_lastbuild' ] = date( "r", mktime() );
			}

			header( "content-type: text/xml" );
			echo $templates -> exectemplate( $main_templates[ 'files_rss_header_html' ], $main_templates[ 'files_rss_header_php' ], $insert ) . "\n";
			$query = $database -> dbquery( "SELECT file_name, file_version, file_seo, file_description, file_date FROM " . DB_PREFIX . "esselbach_ct_files WHERE " . $file_status . " AND file_category = '" . $filecat_id . "' AND (file_website = '0' OR file_website = '" . $preferences[ 'current_website' ] . "')" . $files_expire_sql . " ORDER BY file_date DESC LIMIT 20" );
		}

		if( $database -> dbrows( $query ) )
		{
			if ( $preferences[ 'website_seo_hyphens' ] )
			{
				$preferences[ 'param_action' ] = str_replace( "_", "-", $preferences[ 'param_action' ] );
			}

			while( list( $file_name, $file_version, $file_seo, $file_description, $file_date ) = $database -> dbrow( $query ) )
			{
				if ( $preferences[ 'website_seo_hyphens' ] )
				{
					$file_seo = str_replace( "_", "-", $file_seo );
				}
				$insert[ 'file_name' ] = strip_tags( htmlspecialchars( $file_name ) );
				$insert[ 'file_version' ] = strip_tags( htmlspecialchars( $file_version ) );
				$insert[ 'file_link' ] = strip_tags( $preferences[ 'website_url' ] ) . "/" . $seo_url . "files" . $preferences[ 'param_action' ] . "details" . $preferences[ 'param_page' ] . $file_seo . ".html";
				$insert[ 'file_description' ] = strip_tags( htmlspecialchars( $file_description ) );
				$insert[ 'file_startdate' ] = date( "r", strtotime( $file_date ) );
				echo $templates -> exectemplate( $main_templates[ 'files_rss_item_html' ], $main_templates[ 'files_rss_item_php' ], $insert ) . "\n";
			}
		}

		echo $templates -> exectemplate( $main_templates[ 'files_rss_footer_html' ], $main_templates[ 'files_rss_footer_php' ], $insert );
	}
}
?>