<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) 2.1.16 Update #4                                        |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2012 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | Contentteller is not free software. You may not redistribute this file   |
// | or its derivatives without written permission.                           |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Build: 824.97.120908-140829                                              |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Knowledgebase
 * @copyright (C) 2002-2012 Esselbach Internet Solutions
 */

/**
 * function KnowledgebaseRSS
 * A function to show the RSS feed
 * @author Philipp Louis Esselbach
 */
function KnowledgebaseRSS( $page )
{
	global $database, $system, $templates, $preferences, $config, $security, $user;

	$seo_url = ( $preferences[ 'website_mod_rewrite' ] ) ? "" : "index" . $preferences[ 'param_ext' ] . $preferences[ 'param_ct' ] ;

	if( $preferences[ 'knowledgebase_allow_rss' ] )
	{
		$main_templates = $templates -> preparetemplates( "'knowledgebase_rss_header','knowledgebase_rss_copyright','knowledgebase_rss_editor','knowledgebase_rss_webmaster','knowledgebase_rss_item','knowledgebase_rss_footer'", $preferences[ 'current_theme' ] );

		if( $user[ 'user_status' ] == 1 )
		{
			$knowledgebase_status = "(knowledgebase_status = '0' OR knowledgebase_status = '1' OR knowledgebase_status = '3')";
		}
		elseif( $user[ 'user_status' ] == 2 or $user[ 'user_status' ] == 3 )
		{
			$knowledgebase_status = "(knowledgebase_status = '0' OR knowledgebase_status = '1' OR knowledgebase_status = '2' OR knowledgebase_status = '3' OR knowledgebase_status = '4')";
		}
		elseif( $user[ 'user_status' ] == 6 )
		{
			$knowledgebase_status = "(knowledgebase_status = '0' OR knowledgebase_status = '1' OR knowledgebase_status = '3' OR knowledgebase_status = '4')";
		}
		else
		{
			$knowledgebase_status = "(knowledgebase_status = '0' OR knowledgebase_status = '3')";
		}

		$insert[ 'rss_charset' ] = htmlspecialchars( $preferences[ 'website_charset' ] );
		$insert[ 'rss_pubdate' ] = gmdate( "r", mktime() );
		$insert[ 'rss_language' ] = $preferences[ 'knowledgebase_rss_language' ];

		if( $preferences[ 'knowledgebase_rss_copyright' ] )
		{
			$insert[ 'rss_copyright' ] = strip_tags( $preferences[ 'knowledgebase_rss_copyright' ] );
			$insert[ 'rss_copyright_line' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_rss_copyright_html' ], $main_templates[ 'knowledgebase_rss_copyright_php' ], $insert ) . "\n";
		}
		else
		{
			$insert[ 'rss_copyright_line' ] = "";
		}

		if( $preferences[ 'knowledgebase_rss_editor' ] )
		{
			$insert[ 'rss_editor' ] = strip_tags( $preferences[ 'knowledgebase_rss_editor' ] );
			$insert[ 'rss_editor_line' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_rss_editor_html' ], $main_templates[ 'knowledgebase_rss_editor_php' ], $insert ) . "\n";
		}
		else
		{
			$insert[ 'rss_editor_line' ] = "";
		}

		if( $preferences[ 'knowledgebase_rss_webmaster' ] )
		{
			$insert[ 'rss_webmaster' ] = strip_tags( $preferences[ 'knowledgebase_rss_webmaster' ] );
			$insert[ 'rss_webmaster_line' ] = $templates -> exectemplate( $main_templates[ 'knowledgebase_rss_webmaster_html' ], $main_templates[ 'knowledgebase_rss_webmaster_php' ], $insert ) . "\n";
		}
		else
		{
			$insert[ 'rss_webmaster_line' ] = "";
		}

		if( $preferences[ 'website_stats_rss_readers' ] )
		{
			$stats_month = date( "m" );
			$stats_year = date( "Y" );
			$stats_agent = ( isset( $_SERVER[ 'HTTP_USER_AGENT' ] ) ) ? $security -> checkvar( $_SERVER[ 'HTTP_USER_AGENT' ] ) : "" ;
			$query = $database -> dbquery( "SELECT statrssreader_id FROM " . DB_PREFIX . "esselbach_ct_statsrssreaders WHERE statrssreader_month = '" . $stats_month . "' AND statrssreader_year = '" . $stats_year . "' AND statrssreader_agent = '" . $stats_agent . "' AND statrssreader_website = '" . intval( $config[ 'WEBSITE' ] ) . "' LIMIT 1" );

			if( $database -> dbrows( $query ) )
			{
				$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_statsrssreaders SET statrssreader_count = statrssreader_count + 1 WHERE statrssreader_month = '" . $stats_month . "' AND statrssreader_year = '" . $stats_year . "' AND statrssreader_agent = '" . $stats_agent . "' AND statrssreader_website = '" . intval( $config[ 'WEBSITE' ] ) . "'" );
			}
			else
			{
				$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_statsrssreaders (statrssreader_id, statrssreader_website, statrssreader_month, statrssreader_year, statrssreader_agent, statrssreader_count) VALUES (NULL, '" . intval( $config[ 'WEBSITE' ] ) . "', '" . $stats_month . "', '" . $stats_year . "', '" . $stats_agent . "', '1')" );
			}

			$query = $database -> dbquery( "SELECT statcount_id FROM " . DB_PREFIX . "esselbach_ct_statscounter WHERE statcount_month = '" . $stats_month . "' AND statcount_year = '" . $stats_year . "' AND statcount_website = '" . intval( $config[ 'WEBSITE' ] ) . "' LIMIT 1" );

			if( $database -> dbrows( $query ) )
			{
				$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_statscounter SET statcount_rssviews = statcount_rssviews + 1 WHERE statcount_month = '" . $stats_month . "' AND statcount_year = '" . $stats_year . "' AND statcount_website = '" . intval( $config[ 'WEBSITE' ] ) . "'" );
			}
			else
			{
				$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_statscounter (statcount_id, statcount_website, statcount_month, statcount_year, statcount_pageviews, statcount_rssviews) VALUES (NULL, '" . intval( $config[ 'WEBSITE' ] ) . "', '" . $stats_month . "', '" . $stats_year . "', '0', '1')" );
			}
		}

		if( !$page )
		{
			$insert[ 'rss_sitename' ] = strip_tags( htmlspecialchars(  $preferences[ 'website_name' ] ) );
			$insert[ 'rss_siteurl' ] = strip_tags( $preferences[ 'website_url' ] );
			$insert[ 'rss_description' ] = strip_tags( $preferences[ 'website_description' ] );
			$query = $database -> dbquery( "SELECT knowledgebase_date FROM " . DB_PREFIX . "esselbach_ct_knowledgebase WHERE " . $knowledgebase_status . " AND (knowledgebase_website = '0' OR knowledgebase_website = '" . $preferences[ 'current_website' ] . "') ORDER BY knowledgebase_date DESC LIMIT 1" );

			if( $database -> dbrows( $query ) )
			{
				list( $knowledgebase_date ) = $database -> dbrow( $query );
				$insert[ 'rss_lastbuild' ] = gmdate( "r", strtotime( $knowledgebase_date ) );
			}
			else
			{
				exit;
			}

			header( "content-type: text/xml" );
			echo $templates -> exectemplate( $main_templates[ 'knowledgebase_rss_header_html' ], $main_templates[ 'knowledgebase_rss_header_php' ], $insert ) . "\n";
			$query = $database -> dbquery( "SELECT knowledgebase_question, knowledgebase_seo, knowledgebase_description, knowledgebase_date FROM " . DB_PREFIX . "esselbach_ct_knowledgebase WHERE " . $knowledgebase_status . " AND (knowledgebase_website = '0' OR knowledgebase_website = '" . $preferences[ 'current_website' ] . "') ORDER BY knowledgebase_date DESC LIMIT 20" );
		}
		else
		{
			$page_query = $system -> getpage( $page );
			;
			$query = $database -> dbquery( "SELECT knowledgebasecat_id, knowledgebasecat_name, knowledgebasecat_seo, knowledgebasecat_description FROM " . DB_PREFIX . "esselbach_ct_knowledgebasecats WHERE knowledgebasecat_seo = '" . $page_query . "' AND (knowledgebasecat_website = '0' OR knowledgebasecat_website = '" . $preferences[ 'current_website' ] . "') LIMIT 1" );

			if( $database -> dbrows( $query ) )
			{
				list( $knowledgebasecat_id, $knowledgebasecat_name, $knowledgebasecat_seo, $knowledgebasecat_description ) = $database -> dbrow( $query );
				if ( $preferences[ 'website_seo_hyphens' ] )
				{
					$knowledgebasecat_seo = str_replace( "_", "-", $knowledgebasecat_seo );
				}

				$insert[ 'rss_sitename' ] = strip_tags( htmlspecialchars( $preferences[ 'website_name' ] ) . " - " . strip_tags( $knowledgebasecat_name ) );
				$insert[ 'rss_siteurl' ] = strip_tags( $preferences[ 'website_url' ] ) . "/" . $seo_url . "knowledgebase" . $preferences[ 'param_action' ] . "category" . $preferences[ 'param_page' ] . $knowledgebasecat_seo . ".xml";
				$insert[ 'rss_description' ] = strip_tags( $knowledgebasecat_description );
			}
			else
			{
				exit;
			}

			$knowledgebasecat_id = $database -> dbescape( $knowledgebasecat_id );
			$query = $database -> dbquery( "SELECT knowledgebase_date FROM " . DB_PREFIX . "esselbach_ct_knowledgebase WHERE " . $knowledgebase_status . " AND (knowledgebase_category = '" . $knowledgebasecat_id . "') AND (knowledgebase_website = '0' OR knowledgebase_website = '" . $preferences[ 'current_website' ] . "') ORDER BY knowledgebase_date DESC LIMIT 1" );

			if( $database -> dbrows( $query ) )
			{
				list( $knowledgebase_date ) = $database -> dbrow( $query );
				$insert[ 'rss_lastbuild' ] = gmdate( "r", strtotime( $knowledgebase_date ) );
			}
			else
			{
				$insert[ 'rss_lastbuild' ] = gmdate( "r", mktime() );
			}

			header( "content-type: text/xml" );
			echo $templates -> exectemplate( $main_templates[ 'knowledgebase_rss_header_html' ], $main_templates[ 'knowledgebase_rss_header_php' ], $insert ) . "\n";
			$query = $database -> dbquery( "SELECT knowledgebase_question, knowledgebase_seo, knowledgebase_description, knowledgebase_date FROM " . DB_PREFIX . "esselbach_ct_knowledgebase WHERE " . $knowledgebase_status . " AND (knowledgebase_category = '" . $knowledgebasecat_id . "') AND (knowledgebase_website = '0' OR knowledgebase_website = '" . $preferences[ 'current_website' ] . "')  ORDER BY knowledgebase_date DESC LIMIT 20" );
		}

		if( $database -> dbrows( $query ) )
		{
			if ( $preferences[ 'website_seo_hyphens' ] )
			{
				$preferences[ 'param_action' ] = str_replace( "_", "-", $preferences[ 'param_action' ] );
			}

			while( list( $knowledgebase_question, $knowledgebase_seo, $knowledgebase_description, $knowledgebase_date ) = $database -> dbrow( $query ) )
			{
				if ( $preferences[ 'website_seo_hyphens' ] )
				{
					$knowledgebase_seo = str_replace( "_", "-", $knowledgebase_seo );
				}
				$insert[ 'knowledgebase_question' ] = strip_tags( htmlspecialchars( $knowledgebase_question ) );
				$insert[ 'knowledgebase_link' ] = strip_tags( $preferences[ 'website_url' ] ) . "/" . $seo_url . "knowledgebase" . $preferences[ 'param_action' ] . "entry" . $preferences[ 'param_page' ] . $knowledgebase_seo . ".html";
				$insert[ 'knowledgebase_description' ] = strip_tags( htmlspecialchars( $knowledgebase_description ) );
				$insert[ 'knowledgebase_date' ] = gmdate( "r", strtotime( $knowledgebase_date ) );
				echo $templates -> exectemplate( $main_templates[ 'knowledgebase_rss_item_html' ], $main_templates[ 'knowledgebase_rss_item_php' ], $insert ) . "\n";
			}
		}

		echo $templates -> exectemplate( $main_templates[ 'knowledgebase_rss_footer_html' ], $main_templates[ 'knowledgebase_rss_footer_php' ], $insert );
	}
}
?>