<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) 2.1.16 Update #4                                        |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2012 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | Contentteller is not free software. You may not redistribute this file   |
// | or its derivatives without written permission.                           |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Build: 824.97.120908-140829                                              |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage News
 * @copyright (C) 2002-2012 Esselbach Internet Solutions
 */

/**
 * function NewsRSS
 * A function to show the RSS feed
 * @author Philipp Louis Esselbach
 */
function NewsRSS( $page )
{
	global $database, $system, $templates, $preferences, $security, $config, $user;
	$currentdate = date( "Y-m-d H:i:s", mktime() );

	$seo_url = ( $preferences[ 'website_mod_rewrite' ] ) ? "" : "index" . $preferences[ 'param_ext' ] . $preferences[ 'param_ct' ] ;

	if( $preferences[ 'news_allow_rss' ] )
	{
		$main_templates = $templates -> preparetemplates( "'news_story_rss_header','news_story_rss_copyright','news_story_rss_editor','news_story_rss_webmaster','news_story_rss_item','news_story_rss_footer'", $preferences[ 'current_theme' ] );

		if( $user[ 'user_status' ] == 1 )
		{
			$newsstory_status = "(newsstory_status = '0' OR newsstory_status = '1' OR newsstory_status = '3')";
		}
		elseif( $user[ 'user_status' ] == 2 or $user[ 'user_status' ] == 3 )
		{
			$newsstory_status = "(newsstory_status = '0' OR newsstory_status = '1' OR newsstory_status = '2' OR newsstory_status = '3' OR newsstory_status = '4')";
		}
		elseif( $user[ 'user_status' ] == 6 )
		{
			$newsstory_status = "(newsstory_status = '0' OR newsstory_status = '1' OR newsstory_status = '3' OR newsstory_status = '4')";
		}
		else
		{
			$newsstory_status = "(newsstory_status = '0' OR newsstory_status = '3')";
		}

		if( $preferences[ 'news_start_expire_date' ] )
		{
			$news_expire_sql = " AND newsstory_startdate < '" . $currentdate . "' AND (newsstory_expiredate > '" . $currentdate . "' OR newsstory_neverexpire = '1')";
		}
		else
		{
			$news_expire_sql = "";
		}

		$insert[ 'rss_charset' ] = htmlspecialchars( $preferences[ 'website_charset' ] );
		$insert[ 'rss_pubdate' ] = date( "r", mktime() );
		$insert[ 'rss_language' ] = $preferences[ 'news_rss_language' ];
		$currentdate = date( "Y-m-d H:i:s", mktime() );

		if( $preferences[ 'news_rss_copyright' ] )
		{
			$insert[ 'rss_copyright' ] = strip_tags( $preferences[ 'news_rss_copyright' ] );
			$insert[ 'rss_copyright_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rss_copyright_html' ], $main_templates[ 'news_story_rss_copyright_php' ], $insert ) . "\n";
		}
		else
		{
			$insert[ 'rss_copyright_line' ] = "";
		}

		if( $preferences[ 'news_rss_editor' ] )
		{
			$insert[ 'rss_editor' ] = strip_tags( $preferences[ 'news_rss_editor' ] );
			$insert[ 'rss_editor_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rss_editor_html' ], $main_templates[ 'news_story_rss_editor_php' ], $insert ) . "\n";
		}
		else
		{
			$insert[ 'rss_editor_line' ] = "";
		}

		if( $preferences[ 'news_rss_webmaster' ] )
		{
			$insert[ 'rss_webmaster' ] = strip_tags( $preferences[ 'news_rss_webmaster' ] );
			$insert[ 'rss_webmaster_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rss_webmaster_html' ], $main_templates[ 'news_story_rss_webmaster_php' ], $insert ) . "\n";
		}
		else
		{
			$insert[ 'rss_webmaster_line' ] = "";
		}

		if( $preferences[ 'website_stats_rss_readers' ] )
		{
			$stats_month = date( "m" );
			$stats_year = date( "Y" );
			$stats_agent = ( isset( $_SERVER[ 'HTTP_USER_AGENT' ] ) ) ? $security -> checkvar( $_SERVER[ 'HTTP_USER_AGENT' ] ) : "" ;
			$query = $database -> dbquery( "SELECT statrssreader_id FROM " . DB_PREFIX . "esselbach_ct_statsrssreaders WHERE statrssreader_month = '" . $stats_month . "' AND statrssreader_year = '" . $stats_year . "' AND statrssreader_agent = '" . $stats_agent . "' AND statrssreader_website = '" . intval( $config[ 'WEBSITE' ] ) . "' LIMIT 1" );

			if( $database -> dbrows( $query ) )
			{
				$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_statsrssreaders SET statrssreader_count = statrssreader_count + 1 WHERE statrssreader_month = '" . $stats_month . "' AND statrssreader_year = '" . $stats_year . "' AND statrssreader_agent = '" . $stats_agent . "' AND statrssreader_website = '" . intval( $config[ 'WEBSITE' ] ) . "'" );
			}
			else
			{
				$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_statsrssreaders (statrssreader_id, statrssreader_website, statrssreader_month, statrssreader_year, statrssreader_agent, statrssreader_count) VALUES (NULL, '" . intval( $config[ 'WEBSITE' ] ) . "', '" . $stats_month . "', '" . $stats_year . "', '" . $stats_agent . "', '1')" );
			}

			$query = $database -> dbquery( "SELECT statcount_id FROM " . DB_PREFIX . "esselbach_ct_statscounter WHERE statcount_month = '" . $stats_month . "' AND statcount_year = '" . $stats_year . "' AND statcount_website = '" . intval( $config[ 'WEBSITE' ] ) . "' LIMIT 1" );

			if( $database -> dbrows( $query ) )
			{
				$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_statscounter SET statcount_rssviews = statcount_rssviews + 1 WHERE statcount_month = '" . $stats_month . "' AND statcount_year = '" . $stats_year . "' AND statcount_website = '" . intval( $config[ 'WEBSITE' ] ) . "'" );
			}
			else
			{
				$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_statscounter (statcount_id, statcount_website, statcount_month, statcount_year, statcount_pageviews, statcount_rssviews) VALUES (NULL, '" . intval( $config[ 'WEBSITE' ] ) . "', '" . $stats_month . "', '" . $stats_year . "', '0', '1')" );
			}
		}

		if( !$page )
		{
			$insert[ 'rss_sitename' ] = strip_tags( htmlspecialchars( $preferences[ 'website_name' ] ) );
			$insert[ 'rss_siteurl' ] = strip_tags( $preferences[ 'website_url' ] );
			$insert[ 'rss_description' ] = strip_tags( $preferences[ 'website_description' ] );
			$query = $database -> dbquery( "SELECT newsstory_date FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE " . $newsstory_status . " AND (newsstory_website = '0' OR newsstory_website = '" . $preferences[ 'current_website' ] . "')" . $news_expire_sql . " ORDER BY newsstory_date DESC LIMIT 1" );

			if( $database -> dbrows( $query ) )
			{
				list( $newsstory_date ) = $database -> dbrow( $query );
				$insert[ 'rss_lastbuild' ] = date( "r", strtotime( $newsstory_date ) );
			}
			else
			{
				exit;
			}

			header( "content-type: text/xml" );
			echo $templates -> exectemplate( $main_templates[ 'news_story_rss_header_html' ], $main_templates[ 'news_story_rss_header_php' ], $insert ) . "\n";
			$query = $database -> dbquery( "SELECT newsstory_title, newsstory_seo, newsstory_description, newsstory_date FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE " . $newsstory_status . " AND (newsstory_website = '0' OR newsstory_website = '" . $preferences[ 'current_website' ] . "')" . $news_expire_sql . " ORDER BY newsstory_date DESC LIMIT 20" );
		}
		else
		{
			$page_query = $system -> getpage( $page );
			$query = $database -> dbquery( "SELECT newschannel_key, newschannel_name, newschannel_seo, newschannel_description FROM " . DB_PREFIX . "esselbach_ct_newschannels WHERE newschannel_seo = '" . $page_query . "' AND (newschannel_website = '0' OR newschannel_website = '" . $preferences[ 'current_website' ] . "') LIMIT 1" );

			if( $database -> dbrows( $query ) )
			{
				list( $newschannel_key, $newschannel_name, $newschannel_seo, $newschannel_description ) = $database -> dbrow( $query );

				if ( $preferences[ 'website_seo_hyphens' ] )
				{
					$newschannel_seo = str_replace( "_", "-", $newschannel_seo );
				}

				$insert[ 'rss_sitename' ] = strip_tags( htmlspecialchars( $preferences[ 'website_name' ] ) . " - " . strip_tags( $newschannel_name ) );
				$insert[ 'rss_siteurl' ] = strip_tags( $preferences[ 'website_url' ] ) . "/" . $seo_url . "news" . $preferences[ 'param_action' ] . "channels" . $preferences[ 'param_page' ] . $newschannel_seo . ".xml";
				$insert[ 'rss_description' ] = strip_tags( htmlspecialchars( $newschannel_description ) );
			}
			else
			{
				exit;
			}

			$newschannel_key = $database -> dbescape( $newschannel_key );
			$query = $database -> dbquery( "SELECT newsstory_date FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE " . $newsstory_status . " AND (newsstory_channels LIKE '%" . $newschannel_key . "%') AND (newsstory_website = '0' OR newsstory_website = '" . $preferences[ 'current_website' ] . "')" . $news_expire_sql . " ORDER BY newsstory_date DESC LIMIT 1" );

			if( $database -> dbrows( $query ) )
			{
				list( $newsstory_date ) = $database -> dbrow( $query );
				$insert[ 'rss_lastbuild' ] = date( "r", strtotime( $newsstory_date ) );
			}
			else
			{
				$insert[ 'rss_lastbuild' ] = date( "r", mktime() );
			}

			header( "content-type: text/xml" );
			echo $templates -> exectemplate( $main_templates[ 'news_story_rss_header_html' ], $main_templates[ 'news_story_rss_header_php' ], $insert ) . "\n";
			$query = $database -> dbquery( "SELECT newsstory_title, newsstory_seo, newsstory_description, newsstory_date FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE " . $newsstory_status . " AND (newsstory_channels LIKE '%" . $newschannel_key . "%') AND (newsstory_website = '0' OR newsstory_website = '" . $preferences[ 'current_website' ] . "')" . $news_expire_sql . " ORDER BY newsstory_date DESC LIMIT 20" );
		}

		if( $database -> dbrows( $query ) )
		{
			if ( $preferences[ 'website_seo_hyphens' ] )
			{
				$preferences[ 'param_action' ] = str_replace( "_", "-", $preferences[ 'param_action' ] );
			}

			while( list( $newsstory_title, $newsstory_seo, $newsstory_description, $newsstory_date ) = $database -> dbrow( $query ) )
			{

				if ( $preferences[ 'website_seo_hyphens' ] )
				{
					$newsstory_seo = str_replace( "_", "-", $newsstory_seo );
				}

				$insert[ 'newsstory_title' ] = strip_tags( htmlspecialchars( $newsstory_title ) );
				$insert[ 'newsstory_link' ] = strip_tags( $preferences[ 'website_url' ] ) . "/" . $seo_url . "news" . $preferences[ 'param_action' ] . "story" . $preferences[ 'param_page' ] . $newsstory_seo . ".html";
				$insert[ 'newsstory_description' ] = strip_tags( htmlspecialchars( $newsstory_description ) );
				$insert[ 'newsstory_startdate' ] = date( "r", strtotime( $newsstory_date ) );
				echo $templates -> exectemplate( $main_templates[ 'news_story_rss_item_html' ], $main_templates[ 'news_story_rss_item_php' ], $insert ) . "\n";
			}
		}

		echo $templates -> exectemplate( $main_templates[ 'news_story_rss_footer_html' ], $main_templates[ 'news_story_rss_footer_php' ], $insert );
	}
}
?>